STD_OUTPUT_HANDLE                   equ -11
IMAGE_NUMBEROF_DIRECTORY_ENTRIES    equ 16
MEM_COMMIT                          equ 1000h
PAGE_EXECUTE_READWRITE              equ 40h
GENERIC_WRITE                       equ 40000000h
CREATE_ALWAYS                       equ 2
FILE_ATTRIBUTE_ARCHIVE              equ 20h
MEM_RELEASE                         equ 8000h
INVALID_HANDLE_VALUE                equ -1

STRUC IMAGE_DOS_HEADER
  e_magic           dw      ?
  e_cblp            dw      ?
  e_cp              dw      ?
  e_crlc            dw      ?
  e_cparhdr         dw      ?
  e_minalloc        dw      ?
  e_maxalloc        dw      ?
  e_ss              dw      ?
  e_sp              dw      ?
  e_csum            dw      ?
  e_ip              dw      ?
  e_cs              dw      ?
  e_lfarlc          dw      ?
  e_ovno            dw      ?
  e_res             rw      4
  e_oemid           dw      ?
  e_oeminfo         dw      ?
  e_res2            rw      10
  e_lfanew          dd      ?
ENDS

STRUC IMAGE_FILE_HEADER
  Machine               dw    ?
  NumberOfSections      dw    ?
  TimeDateStamp         dd    ?
  PointerToSymbolTable  dd    ?
  NumberOfSymbols       dd    ?
  SizeOfOptionalHeader  dw    ?
  Characteristics       dw    ?
ENDS

STRUC IMAGE_DATA_DIRECTORY
  VirtualAddress    dd     ?
  isize             dd     ?
ENDS

STRUC IMAGE_EXPORT_DIRECTORY
  Characteristics           dd      ?
  TimeDateStamp             dd      ?
  MajorVersion              dw      ?
  MinorVersion              dw      ?
  nName                     dd      ?
  nBase                     dd      ?
  NumberOfFunctions         dd      ?
  NumberOfNames             dd      ?
  AddressOfFunctions        dd      ?
  AddressOfNames            dd      ?
  AddressOfNameOrdinals     dd      ?
ENDS

STRUC IMAGE_OPTIONAL_HEADER32
  Magic                         dw      ?
  MajorLinkerVersion            db      ?
  MinorLinkerVersion            db      ?
  SizeOfCode                    dd      ?
  SizeOfInitializedData         dd      ?
  SizeOfUninitializedData       dd      ?
  AddressOfEntryPoint           dd      ?
  BaseOfCode                    dd      ?
  BaseOfData                    dd      ?
  ImageBase                     dd      ?
  SectionAlignment              dd      ?
  FileAlignment                 dd      ?
  MajorOperatingSystemVersion   dw      ?
  MinorOperatingSystemVersion   dw      ?
  MajorImageVersion             dw      ?
  MinorImageVersion             dw      ?
  MajorSubsystemVersion         dw      ?
  MinorSubsystemVersion         dw      ?
  Win32VersionValue             dd      ?
  SizeOfImage                   dd      ?
  SizeOfHeaders                 dd      ?
  CheckSum                      dd      ?
  Subsystem                     dw      ?
  DllCharacteristics            dw      ?
  SizeOfStackReserve            dd      ?
  SizeOfStackCommit             dd      ?
  SizeOfHeapReserve             dd      ?
  SizeOfHeapCommit              dd      ?
  LoaderFlags                   dd      ?
  NumberOfRvaAndSizes           dd      ?
  DataDirectory                 rs IMAGE_DATA_DIRECTORY IMAGE_NUMBEROF_DIRECTORY_ENTRIES
ENDS

STRUC IMAGE_NT_HEADERS
  Signature         dd                          ?
  FileHeader        rs IMAGE_FILE_HEADER        1
  OptionalHeader    rs IMAGE_OPTIONAL_HEADER32  1
ENDS

import_dll kernel32.dll

    import_func CloseHandle
    import_func CreateFile alias CreateFileA
    import_func ExitProcess
    import_func FreeLibrary
    import_func GetCommandLine alias GetCommandLineA
    import_func GetFullPathName alias GetFullPathNameA    
    import_func GetStdHandle
    import_func LoadLibrary alias LoadLibraryA
    import_func VirtualAlloc
    import_func VirtualFree
    import_func WriteFile
